-- Auto generated script file --

vanilla_model.PLAYER:setVisible(false) -- Hide vanilla models cuz they are wierd for 4-footed fob
vanilla_model.CAPE:setVisible(false) -- You can draw cape using blockbench and set this to true
vanilla_model.ELYTRA:setVisible(false) -- Please use the elytra drawn in blockbench
vanilla_model.ARMOR:setVisible(false) -- Don't set it to ture, or else you'll become very compacted with armor if you do wear any.
renderer:setRenderRightArm(false) -- Hide First Person Hand cuz it's weird

-- To adjust the eye height and hitbox for your model, please do /scale set acoordingly using Pehkui
-- The mcfunction only adjust to the optimal stats for the fox avatar 

-- Registering some variables
-- Replace the stuff after "=" to your needs, in case you renamed some animations
-- Not recommended to touch the stuff before it, they will be called later
local tail_wag = animations.model.tail_wag -- Ambient Tail Wagging :3
local crouch = animations.model.crouch -- Crouch
local shake = animations.model.shake -- Shake water / snow
local sit = animations.model.sit -- Sit
local pounce = animations.model.pounce --Pounce
local close_wing = animations.model.close_wing -- Close wing when not fall flying
local sleep = animations.model.sleep -- Eepy
-- The below animations manually turn the avatar 90 degrees so it wont look wierd
local swim = animations.model.swim -- Swim
local unswim = animations.model.unswim -- Unswim Animation
local sleepBed = animations.model.sleep_bed -- Bed Eepy
local fall_flying = animations.model.fall_flying -- Fall Flying
local riptide = animations.model.riptide -- Riptide Spin

-- The main script part, no touch if no know >:3
-- If you need more Origin-Figura cross connection for this fox origins, lemme know via Origins discord

-- man idk how lua works

-- Tail start wagging from the beginning :3
tail_wag:play()

-- Some functions --
function sleepAnimation()
    closeEyes()
    sit:stop()
    tail_wag:stop()
    sleep:play()
end

function unsleepAnimation()
    openEyes()
    sleep:stop()
    sleepBed:stop()
    tail_wag:restart()
end

function sleepBedAnimation()
    closeEyes()
    sit:stop()
    tail_wag:stop()
    sleepBed:play()
end

function resetWing()
    if not (player:getPose() == "FALL_FLYING" or
            sit:isPlaying() or
            sleep:isPlaying() or
            sleepBed:isPlaying() or
            shake:isPlaying() or
            pounce:isPlaying() or
            swim:isPlaying()
            ) then
                close_wing:play()
        else
            close_wing:stop()
        end
    end

-- Close eyes when eepy
-- Close eyes by shifting UV of the Textures up by 1 pixel :3
faceModel = models.model.root.Head.Eyes
function closeEyes()
    faceModel:setUV(0,1/32)
end

function openEyes()
    faceModel:setUV(0,0)
end

-- A mysterious function inspired by Splat from Discord
function getPower(t)
    temp = 0

    for _,_,_ in pairs(t) do
        temp = temp + 1
    end
    return temp
end

-- Ticking functions
function events.tick()
    local powerList
    local isFabric
    if player:getNbt()["cardinal_components"] then
        powerList = player:getNbt()["cardinal_components"]["apoli:powers"]["Powers"]
        isFabric = true
    else
        powerList = player:getNbt()["ForgeCaps"]["apoli:powers"]["Powers"]
        isFabric = false
    end

    getPower(powerList) -- Retrieve the number of powers the player has

    -- Good to have isLoaded() in front of everything
    if player:isLoaded() then

        -- Speed up Tail wag :3
        if player:isSprinting() then
            tail_wag:setSpeed(7)
        elseif player:getVelocity():length() > 0 then
            tail_wag:setSpeed(5)
        else
            tail_wag:setSpeed(1)
        end

        -- Crouching
        crouch:setPlaying(player:getPose() == "CROUCHING") 

        -- Swim Pose (Rotated by 90)
        if player:getPose() == "SWIMMING" then
            unswim:stop()
            swim:play()
            elseif swim:isPlaying() then
                unswim:play()
                swim:stop()
        end

        -- Elytra Flight (Rotated by 90)
        if player:getPose() == "FALL_FLYING" then
            pounce:stop()
            fall_flying:play()
            elseif fall_flying:isPlaying() then
                fall_flying:stop()
        end

        -- Riptide Spiiiin (Rotated by 90)
        if player:getPose() == "SPIN_ATTACK" then
            riptide:play()
            elseif riptide:isPlaying() then
                riptide:stop()
        end

        -- Unsit and Unsleep
        if player:getVelocity():length() > 0 then
            sit:stop()
            if sleepBed:isPlaying() and player:getNbt()["SleepTimer"] == 0 then
                unsleepAnimation()
            end
        end

        -- Sleep Animation but Tuned to Bed (Rotated by 90)
        -- This Does not work if you go bed while falling
        if player:getPose() == "SLEEPING" then
            if sleep:isPlaying() then
                unsleepAnimation()
            end
            sleepBedAnimation()
        end

        -- CloseWing play or stop under various conditions
        resetWing()

        for index = 1, temp do
            -- This resource is for shaking, specifically created for this script to detect
            if powerList[index]["Type"] == "thorigins:fox/thfluffy_is_shaking" then
                if isFabric then
                    is_shaking = powerList[index]["Data"]
                else
                    is_shaking = powerList[index]["Data"].Value
                end
            -- This resource is for tracking [Sleepin Mode] [0, 1200]
            elseif powerList[index]["Type"] == "thorigins:fox/thfoxify_afk_timer" then
                if isFabric then
                    afk_timer = powerList[index]["Data"]
                else
                    afk_timer = powerList[index]["Data"].Value
                end
            -- This resource is for pouncing [0 / 1]
            elseif powerList[index]["Type"] == "thorigins:fox/thdash_left_ground" or powerList[index]["Type"] == "thorigins:kitsune/thdash2_left_ground" or powerList[index]["Type"] == "thorigins:ninetails/thdash3_left_ground" then
                if isFabric then
                    pouncing = powerList[index]["Data"]
                else
                    pouncing = powerList[index]["Data"].Value
                end
            end
        end

        -- The below animations actively read Origin resources through player NBT
        -- Ignore this part if you are not using the Fox Origin
        -- Shake
        if is_shaking then 
            if is_shaking == 1 then
                shake:play()
            else
                shake:stop()
            end
        end

        if afk_timer then
            if afk_timer == 0 and player:getPose() == "STANDING" and not sit:isPlaying() then
                sleepAnimation()
            elseif afk_timer > 1195 and tail_wag:isStopped() then
                unsleepAnimation()
            end
        end

        if pouncing == 1 then
            if player:getNbt()["OnGround"] == 0 then
                if not fall_flying:isPlaying() then
                    pounce:play()
                    tail_wag:setSpeed(1)
                end
            end
        elseif pounce:isPlaying() then
            pounce:stop()
        end
    end
end

-- Action Wheel
local emotes = action_wheel:newPage()
action_wheel:setPage(emotes)

-- Sleep Emote
local action = emotes:newAction()
    :title("Sleep")
    :item("minecraft:red_bed")
    :hoverColor(1,0,1)
    :onLeftClick(
        function()
            sleepAnimation()
        end
    )

-- Sit Emote
local action = emotes:newAction()
    :title("Sit")
    :item("minecraft:scaffolding")
    :hoverColor(1,0,1)
    :onLeftClick(
        function()
            sleep:stop()
            sit:play()
        end
    )